//---------------------------------------------------------------------------
// Generowanie kodow kreskowych EAN2
// www.algorytm.org
// (c)2005 Tomasz Lubinski

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}

byte EAN2[15];
byte bars[20];

byte parityTable[10][6] = {
        {0, 0, 0, 0, 0, 0},
        {0, 0, 1, 0, 1, 1},
        {0, 0, 1, 1, 0, 1},
        {0, 0, 1, 1, 1, 0},
        {0, 1, 0, 0, 1, 1},
        {0, 1, 1, 0, 0, 1},
        {0, 1, 1, 1, 0, 0},
        {0, 1, 0, 1, 0, 1},
        {0, 1, 0, 1, 1, 0},
        {0, 1, 1, 0, 1, 0}
        };

byte right[10][7] = {
        {1, 1, 1, 0, 0, 1, 0},
        {1, 1, 0, 0, 1, 1, 0},
        {1, 1, 0, 1, 1, 0, 0},
        {1, 0, 0, 0, 0, 1, 0},
        {1, 0, 1, 1, 1, 0, 0},
        {1, 0, 0, 1, 1, 1, 0},
        {1, 0, 1, 0, 0, 0, 0},
        {1, 0, 0, 0, 1, 0, 0},
        {1, 0, 0, 1, 0, 0, 0},
        {1, 1, 1, 0, 1, 0, 0}
        };

byte left[2][10][7] = {
                {
                        {0, 0, 0, 1, 1, 0, 1},
                        {0, 0, 1, 1, 0, 0, 1},
                        {0, 0, 1, 0, 0, 1, 1},
                        {0, 1, 1, 1, 1, 0, 1},
                        {0, 1, 0, 0, 0, 1, 1},
                        {0, 1, 1, 0, 0, 0, 1},
                        {0, 1, 0, 1, 1, 1, 1},
                        {0, 1, 1, 1, 0, 1, 1},
                        {0, 1, 1, 0, 1, 1, 1},
                        {0, 0, 0, 1, 0, 1, 1}
                },
                {
                        {0, 1, 0, 0, 1, 1, 1},
                        {0, 1, 1, 0, 0, 1, 1},
                        {0, 0, 1, 1, 0, 1, 1},
                        {0, 1, 0, 0, 0, 0, 1},
                        {0, 0, 1, 1, 1, 0, 1},
                        {0, 1, 1, 1, 0, 0 ,1},
                        {0, 0, 0, 0, 1, 0, 1},
                        {0, 0, 1, 0, 0, 0 ,1},
                        {0, 0, 0, 1, 0, 0, 1},
                        {0, 0, 1, 0, 1, 1, 1}
                }
        };

byte checksumTable[4][2] = {
        {0, 0},
        {0, 1},
        {1, 0},
        {1, 1}
        };

//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
        int i, j;
        int addCheckSum;

        if (Kod->Text.Length() != 2) {
                ShowMessage("Incorrect EAN2 number");
                return;
        }

        for (i=0; i<2; i++) {
                EAN2[i] = Kod->Text[i+1] - 48;
        }

        for (i=0; i<20; i++) {
                bars[i] = 0;
        }

        addCheckSum = EAN2[0]*10 + EAN2[1];
        addCheckSum %= 4;

        bars[0] = 1;
        bars[1] = 0;
        bars[2] = 1;
        bars[3] = 1;

         for (i=0; i<2; i++) {
                for (j=0; j<7; j++) {
                        bars[i*9 + 4 + j] = left[checksumTable[addCheckSum][i]][EAN2[i]][j];
                }
                if (i<1) {
                        bars[i*9 + 11] = 0;
                        bars[i*9 + 12] = 1;
                }
        }

        DrawBars();

}
//---------------------------------------------------------------------------

void TForm1::DrawBars()
{
        int i, length;

        Image1->Canvas->Brush->Color = clWhite;
        Image1->Canvas->Rectangle(0, 0, 121, 121);
        Image1->Canvas->Brush->Color = clBlack;

        Image1->Canvas->Font->Size = 10;
        Image1->Canvas->Brush->Color = clWhite;
        Image1->Canvas->Font->Color = clBlack;

        for (i=0; i<20; i++) {
                if (bars[i] == 1) {
                        Image1->Canvas->Rectangle(i*2 + 20, 40, i*2 + 22, 100);
                }
        }

        for (i=0; i<2; i++) {

                Image1->Canvas->TextOutA(i*16 + 26, 20, IntToStr(EAN2[i]));
        }

}

//---------------------------------------------------------------------------



